
<!---
DESCRIPTION:
	This tag will set a session variable to "No" When used in conjunction with
	BR_Login it gives the abity to login (BR_Login) and logout (BR_Logout) of
	a directory structure.

ATTRIBUTES:
	Datasource		(required)	=	Datasouce that that contains the table to 
									be checked.
	SessionLogin	(required)	=	The name of the session variable that you 
									want to be set to "No" when the user confirms
									their logout.
	ReturnTo		(optional)	=	The name of the page you want the user to be
									CFLOCATIONed to after log out. Default is "/".

NOTES:
	Designed to be used with the BR_LoginTag. Set the SessionLogin attribute the 
	same in both tags.

USAGE:


EXAMPLES:
	<CF_BR_LogOut 
		Datasource="#DataSource#" 
		SessionLogin="AmILoggedIn" 
		ReturnTo="/cf_tags">

AUTHOR:
Lance Shepard	(lance@brslc.com) 07/30/99

--->
<!--- This Variable sets the action for all the CFFORM tags to be the template that the tag
	is being called from --->
<CFSET ThisPage =#CGI.SCRIPT_NAME#>
<CFIF #CGI.QUERY_STRING# EQ "">
	<CFSET ThisURLPARAM = "">
<CFELSE>
	<CFSET ThisURLPARAM = "?#CGI.QUERY_STRING#">
</CFIF>
<CFSET ThisForm = "#ThisPage##ThisURLPARAM#">


<CFPARAM NAME="Process" DEFAULT="No">
<CFSET Error="No">
<CFSET ErrorMessage="">

<!--- Set the Webmaster from the attributes if it is there or if it is in the caller template 
		otherwise use the CF Admin Email in the registry --->
<CFIF (#IsDefined("Attributes.Webmaster")#) AND (#TRIM(Attributes.Webmaster)# NEQ "")>
	<CFSET Webmaster = "#Attributes.Webmaster#">
<CFELSEIF (#IsDefined("Caller.Webmaster")#) AND (#TRIM(Caller.Webmaster)# NEQ "")>
	<CFSET Webmaster = "#Caller.Webmaster#">
<CFELSE>
	<CFREGISTRY ACTION="GET" BRANCH="HKEY_LOCAL_MACHINE\Software\Allaire\ColdFusion\CurrentVersion\Logging" ENTRY="AdminEMail" VARIABLE="CFAdminEMail" TYPE="String">
	<CFSET Webmaster = "#CFAdminEMail#">
</CFIF>
		
<CFIF NOT IsDefined("Attributes.Datasource")>
	<CFSET Error="Yes">
	<CFSET ErrorMessage="<LI>No Datasource was specified in the CF_BR_LogOut tag.">
</CFIF>

<CFIF #Error# EQ "Yes">
	<CFOUTPUT>
		<H2>The following errors have occurred please contact the <A HREF="mailto:#webmaster#?subject=error on #thisForm#&body=#errormessage#">webmaster</A>.</H2>
		<UL>#ErrorMessage#</UL>
	</CFOUTPUT>
	<CFEXIT METHOD="EXITTAG">
</CFIF>

<CFIF #Process# EQ "Yes">
	<CFSET ThisLogin = "Session.#Attributes.SessionLogin#">
	<CFSET "#ThisLogin#" = "No">
	<CFSET rc=StructClear(Session)>
	<CFLOCATION URL="#Attributes.ReturnTo#" ADDTOKEN="No"> 
</CFIF>

<CFFORM ACTION="#ThisForm#">
<H2>Are you sure you want to Log Out?</H2>
<INPUT TYPE="submit" NAME="Process" VALUE="Yes">
</CFFORM>
