
<!---
DESCRIPTION:
	This tag will validate a user login from a given datasource, table, and any
	two (or three see SessionLoginID) fields in the given table. This tag is to 
	be used in an application template. The tag will block any CFML from being 
	processed by any template that uses that application template that contains 
	the BR_login tag.
	
	Two session variables will be set. The first variable is user defined in
	the SessionLogin attribute. This session variable will be set to "Yes" if the va

ATTRIBUTES:
	Datasource		(required)	=	Datasouce that that contains the table to 
									be checked.
	SessionLogin	(required)	=	The name of the session variable that you 
									want to be set to "Yes" if the user is
									validated.
	SessionLoginID	(required)	=	The name of the field that contains the 
									data that will be contained in the 
									#Session.LoginID# variable.
	Tablename		(required)	=	The name of the table that contains the 
									UserField, PasswordField, and SessionLoginID
									fields.
	UserField		(required)	=	The name of the field that contains the user's
									name.
	PasswordField	(required)	=	The name of the field that contains the 
									password.
	UserNameText	(optional)	=	The test that the user will see on the login 
									form that corresponds to the UserName field.
									This will default to "User Name"
	Passwordtext	(optional)	=	The test that the user will see on the login 
									form that corresponds to the Password field.
									This will default to "Password"
	UserFormSize	(optional)	=	The size of the input object on the login
									form. the size will default to 10
	UserFormMax		(optional)	=	The maxLength of the input object on the
									login form. The maxLegnth will default to 10.
	PasswordFormSize(optional)	=	The size of the input object on the login
									form. the size will default to 10
	PasswordFormMax	(optional)	=	The maxLength of the input object on the
									login form. The maxLegnth will default to 10.
	BGColor			(optional)	=	The background color of the login page, the
									default is navy(if using hexcolor omit the
									leading	#).
	LightColor		(optional)	=	The color for the "Please Login" box, default is
									is SlateBlue. (if using hexcolor omit the
									leading #).
	TextColor		(optional)	=	The color for the text, default is White. (if
									using hexcolor omit the leading #).									
	IncludedSubRoutine
					(optional)	=	A comma delimited list of files or tags to be
									"CFINCLUDE"d. The tags must be in the same
									directory that is calling this login or in the
									"Custom Tag" directory.
	Mapping			(optional)	=	If the is a mapping for you CF server that you
									are using put it here other wise it is assumed
									that you are on your own server and the 
									CFINCLUDE does not need any mapping.
	AdditionalText	(optional)	=	Any additional text you want to include for the
									user. Don't for get to double up the double 
									quotes.
	Graphic			(optional)	=	Graphic to appear at the top of the Login.	
	Webmaster		(optional)	=	If an error in the tag ocurres who ya gonna call
	
NOTES:
	The login IS case-sensitive.

USAGE:
	Best used in an application file in a director that you want to restrict. See
	the example.

EXAMPLES:
	<CFAPPLICATION NAME="TheseSessions" SESSIONMANAGEMENT="Yes">
	
	<CFPARAM NAME="Session.AmILoggedIn" DEFAULT="No">
	
	<CFIF #Session.AmILoggedIn# EQ "No">
		<CF_BR_Login Datasource="#DataSource#" 
			SessionLogin="AmILoggedIn" 
			SessionLoginID="UserID" 
			TableName="UserTable" 
			UserField="UserName" 
			UserFormMax="20"
			PasswordField="Password" 
			AdditionalText="If you have forgotten you password 
							email the <A HREF=""mailto:webmaster@domain.com"">
							webmaster</A>"
			BGColor="White"
			Graphic="/images/VB.gif">
	</CFIF>
	
	The result is two variable
		#Session.AmILoggedIn#	=	"Yes"
		#Session.LoginID#		=	"the value in the UserID field of the UserTable

AUTHOR:
	Lance Shepard	(lance@blueridgesolutions.com) 7/22/99

--->
<html>
<head>
	<title>Please Login In</title>

<CFPARAM NAME="Attributes.Datasource">
<CFPARAM NAME="Attributes.SessionLogin">
<CFPARAM NAME="Attributes.SessionLoginID">
<CFPARAM NAME="Attributes.TableName">
<CFPARAM NAME="Attributes.UserField">
<CFPARAM NAME="Attributes.PasswordField">
<CFPARAM NAME="Attributes.Webmaster" DEFAULT="">
<CFPARAM NAME="Attributes.IncludedSubRoutine" DEFAULT="">
<CFPARAM NAME="Attributes.mapping" DEFAULT="/">
<CFPARAM NAME="Attributes.LightColor" DEFAULT="SlateBlue">
<CFPARAM NAME="Attributes.BGColor" DEFAULT="Navy">
<CFPARAM NAME="Attributes.TextColor" DEFAULT="White">
<CFPARAM NAME="Attributes.UserFormSize" DEFAULT="10">
<CFPARAM NAME="Attributes.UserFormMax" DEFAULT="10">
<CFPARAM NAME="Attributes.PasswordFormSize" DEFAULT="10">
<CFPARAM NAME="Attributes.PasswordFormMax" DEFAULT="10">
<CFPARAM NAME="Attributes.UserNameText" DEFAULT="User Name">
<CFPARAM NAME="Attributes.PasswordText" DEFAULT="Password">
<CFPARAM NAME="Attributes.AdditionalText" DEFAULT="">
<CFPARAM NAME="Attributes.Graphic" DEFAULT="">

<CFSET Error="No">
<CFSET ErrorMessage="">
<CFSET PassLogin="No">
<!--- This Variable sets the action for all the CFFORM tags to be the template that the tag is being called from --->
<CFSET ThisForm = "#CGI.SCRIPT_NAME#">
<CFSET AllowToContinue = "No">
<!--- Set the Webmaster from the attributes if it is there or if it is in the caller template 
		otherwise use the CF Admin Email in the registry --->
<CFIF #TRIM(Attributes.Webmaster)# NEQ "">
	<CFSET Webmaster = "#Attributes.Webmaster#">
<CFELSE>
	<CFREGISTRY ACTION="GET" BRANCH="HKEY_LOCAL_MACHINE\Software\Allaire\ColdFusion\CurrentVersion\Logging" ENTRY="AdminEMail" VARIABLE="CFAdminEMail" TYPE="String">
	<CFSET Webmaster = "#CFAdminEMail#">
</CFIF>
		
<CFIF NOT IsDefined("Attributes.Datasource")>
	<CFSET Error="Yes">
	<CFSET ErrorMessage="#ErrorMessage#<LI>No Datasource was specified in the CF_BR_Login tag.">
</CFIF>

<CFIF NOT IsDefined("Attributes.TableName")>
	<CFSET Error="Yes">
	<CFSET ErrorMessage="#ErrorMessage#<LI>No TableName was specified in the CF_BR_Login tag.">
</CFIF>
<CFIF NOT IsDefined("Attributes.UserField")>
	<CFSET Error="Yes">
	<CFSET ErrorMessage="#ErrorMessage#<LI>No User Field was specified in the CF_BR_Login tag.">
</CFIF>
<CFIF NOT IsDefined("Attributes.PasswordField")>
	<CFSET Error="Yes">
	<CFSET ErrorMessage="#ErrorMessage#<LI>No Password Field was specified in the CF_BR_Login tag.">
</CFIF>
</head>


<CFIF #Error# EQ "Yes">
	<CFOUTPUT>
		The following error(s) have occurred please contact the <A HREF="mailto:#webmaster#?subject=error on #thisForm#&body=#errormessage#">webmaster</A>.<BR>
		<UL>#ErrorMessage#</UL>
	</CFOUTPUT>
	<CFABORT>
</CFIF>
	
<CFIF Attributes.IncludedSubRoutine NEQ "">
	<CFSET ThisTag = "CF_#Attributes.IncludedSubRoutine#">
	<CFOUTPUT>
	<#ThisTag# Datasource="#Attributes.Datasource#">	
	</CFOUTPUT>
</CFIF>


<!--- If there are no form fields passed then  --->
<CFIF (IsDefined("form.Fieldnames") EQ "Yes") AND (IsDefined("form.UserName") EQ "Yes")>
	<CFQUERY Datasource="#Attributes.Datasource#" NAME="Testlogin">
		SELECT *
		FROM #Attributes.TableName#	
		WHERE #Attributes.UserField# = '#form.UserName#' AND #Attributes.PasswordField# = '#form.Password#'
	</CFQUERY>
	<CFIF #Testlogin.RecordCount# EQ 1>
		<CFIF IsDefined("TestLogin.BloodBankID")>
			<CFSET Caller.BBankID = "#TestLogin.BloodBankID#">
		</CFIF>
		<CFSET TestUserField = "TestLogin.#Attributes.UserField#">
		<CFSET TestPasswordField = "TestLogin.#Attributes.PasswordField#">
		<CFSET Comparison = #Compare(TRIM(EValuate(TestUserField)), TRIM(form.UserName))#>
		<CFIF #Comparison# EQ 0>
			<CFSET Comparison = #Compare(TRIM(EValuate(TestPasswordField)), TRIM(form.Password))#>
		</CFIF>
		
		<CFIF #Comparison# EQ 0>
						
			<CFSET ThisLogin = "Session.#Attributes.SessionLogin#">
			<CFSET "#ThisLogin#" = "Yes">
			<CFSET LoginIDField = "TestLogin.#Attributes.SessionLoginID#">
			<CFSET Session.LoginID = "#EVALUATE(LoginIDField)#">
			<CFSET AllowToContinue = "Yes">
			
			<CFIF #Attributes.IncludedSubRoutine# NEQ "">
				<CFSET thisPath=ExpandPath("*.*")>
				<CFSET thisDirectory=GetDirectoryFromPath(thisPath)>
				<CFREGISTRY ACTION="GET" BRANCH="HKEY_LOCAL_MACHINE\Software\Allaire\ColdFusion\CurrentVersion\CustomTags" ENTRY="CFMLTagSearchPath" VARIABLE="cfTagsDirectory" TYPE="String">

				<CFLOOP INDEX="ThisList" LIST="#Attributes.IncludedSubRoutine#" DELIMITERS=",">
					<CFIF #RIGHT(ThisList,4)# NEQ ".cfm">
						<CFSET ThisList = "#ThisList#.cfm">
					</CFIF>
					<CFSET FileInThisDirectory = "#thisDirectory##ThisList#">
					<CFSET FileInCustomTags = "#cfTagsDirectory#\#ThisList#">
										
					<CFIF FileExists("#FileInThisDirectory#")>
						<CFSET RelativeDirectory = "#REPLACE("#CGI.SCRIPT_NAME#","#ListLast("#CGI.SCRIPT_NAME#","/")#","")#">
						<CFSET RelativeDirectory = "#REPLACE("#RelativeDirectory#","/","")#">
						<CFINCLUDE TEMPLATE="#Attributes.mapping##RelativeDirectory##ThisList#">
					<CFELSEIF FileExists("#FileInCustomTags#")>
						<CFINCLUDE TEMPLATE="#ThisList#">
					<CFELSE>
						<!-- Ran nothing -->
					</CFIF>
					
				</CFLOOP>
			</CFIF>

			<CFEXIT>
		<CFELSE>
			<CFSET Attributes.AdditionalText = "<B>We are sorry but we are unable to authenticate your login.<BR>Please Try Again.</B>">
		</CFIF>
	<CFELSE>
		<CFSET Attributes.AdditionalText = "<B>We are sorry but we are unable to authenticate your login.<BR>Please Try Again.</B>">
	</CFIF>
		
</CFIF>


<CFIF #AllowToContinue# EQ "No">
<CFOUTPUT>
<body BGCOLOR="#Attributes.BGColor#" TEXT="#Attributes.TextColor#" onLoad="document.LoginForm.Username.focus()">
</CFOUTPUT>
	
	<CFOUTPUT>	


	
	<CFFORM ACTION="#ThisForm#" NAME="LoginForm">
	
	
	<CFIF #TRIM(Attributes.Graphic)# NEQ "">
	<TABLE BORDER="0" CELLPADDING="10" WIDTH="50%">
	<TR>
		<TD COLSPAN="2" ALIGN="center"><IMG SRC="#Attributes.Graphic#"></TD>
	</TR>
	</TABLE>
	</CFIF>
	<TABLE BORDER="1" CELLPADDING="10" WIDTH="50%">
	<TR>
		<TD COLSPAN="2" ALIGN="center" BGCOLOR="#Attributes.LightColor#"><SPAN STYLE="font-size: 24pt;"><B>Please Login</B></SPAN><BR><SPAN STYLE="font-size: 12pt;">(CasE SenSiTIve)</SPAN></TD>
	</TR>
	<CFIF #TRIM(Attributes.AdditionalText)# NEQ "">
	<TR>
		<TD COLSPAN="2">#Attributes.AdditionalText#</TD>
	</TR>
	</CFIF>
	<TR>
		<TD>#Attributes.UserNameText#:</TD>
		<TD><CFINPUT TYPE="Text" NAME="Username" MESSAGE="You must enter your User Name" REQUIRED="Yes" SIZE="#Attributes.UserFormSize#" MAXLENGTH="#Attributes.UserFormMax#"></TD>
	</TR>
	<TR>
		<TD>#Attributes.PasswordText#:</TD>
		<TD><CFINPUT TYPE="Password" NAME="Password" MESSAGE="You must enter your Password" REQUIRED="Yes" SIZE="#Attributes.PasswordFormSize#" MAXLENGTH="#Attributes.PasswordFormMax#"></TD>
	</TR>
	<TR>
		<TD COLSPAN="2" ALIGN="center"><INPUT TYPE="submit" NAME="CheckLogin" VALUE="Check Login"></TD>
	</TR>
	</TABLE>
	
	</CFFORM>
	
	</CFOUTPUT>
	
	</body>
	</html>
	<CFABORT>
</CFIF>
